/* IMPLEMENTATION MODULE io */

#ifndef M2_IMPORT_buffer
	#include "buffer.c"
	#define M2_IMPORT_buffer
#endif

void io_0err_entry_get(int i, char **m, char **f, int *l);
#include <fcntl.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/select.h>

/* 56*/ void
/* 56*/ io_Open(int try_section, RECORD **io_f, STRING *io_fn, STRING *io_fl)
/* 56*/ {
/* 57*/ 	int io_fd = 0;
/* 58*/ 	void * io_b = NULL;
/* 59*/ 	int io_mode = 0;
/* 60*/ 	int io_flags = 0;
/* 61*/ 	STRING * io_c = NULL;
	int g, i, io_unbuffered;
	char *n, *m;
/* 64*/ 	m2runtime_mark(&io_fl);
/* 65*/ 	*io_f = NULL;
/* 66*/ 	if( m2runtime_InvalidZString(io_fn) ){
/* 67*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 0, 22, m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_fn), (STRING *) "\0\0\0\0\54\0\0\000: pathfile NIL or containing a NUL character", 1));
/* 69*/ 		return ;
/* 70*/ 	}
	io_mode = 0;
	io_flags = 0;
	io_unbuffered = 0;
	if( io_fl != NULL ){
		for( i = 0; i < io_fl->len; i++ ){
			switch( io_fl->s[i] ){

			case 'r': io_mode |= 1; break;
			case 'w': io_mode |= 2; break;

			case 'U': io_unbuffered = 1; break;

			case 'a': io_flags |= O_APPEND; break;
			case 'c': io_flags |= O_CREAT; break;
			case 'e': io_flags |= O_EXCL; break;
			case 'n': io_flags |= O_NONBLOCK; break;
			case 's': io_flags |= O_SYNC; break;
			case 't': io_flags |= O_TRUNC; break;
			case 'y': io_flags |= O_NOCTTY; break;
			case 'f':
#if defined(M2_SYSTEM_TYPE_BSD) || defined(M2_SYSTEM_TYPE_LINUX)
				io_flags |= O_NOFOLLOW;
#endif
				break;
			default:
				io_c = new_STRING(io_fl->s + i, 1);
/* 96*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 1, 22, m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\15\0\0\000unknown flag ", m2runtime_StringToLiteral(io_c), 1));
/* 98*/ 	return ;
			}
		}
	}
	if( io_mode == 0 ){
/*102*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 2, 22, (STRING *) "\0\0\0\0\30\0\0\000required mode w, r or rw");
/*104*/ 	return ;
	} else if( io_mode == 1 )
		g = O_RDONLY;
	else if( io_mode == 2 )
		g = O_WRONLY;
	else
		g = O_RDWR;
	g |= io_flags;
	MK_ZSTRING(n, io_fn);
	io_fd = open(n, g, 0777);
/*113*/ 	if( (io_fd == -1) ){
/*114*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 3, m2runtime_errno(), m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_fn), (STRING *) "\0\0\0\0\2\0\0\000: ", m2runtime_strerror(), 1));
/*116*/ 		return ;
/*117*/ 	}
/*117*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 16, io_0err_entry_get, 4) = io_fd;
/*118*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 20, io_0err_entry_get, 5) = TRUE;
	if( g & O_NONBLOCK ){
		if( ! io_unbuffered ){
/*121*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 6, 22, (STRING *) "\0\0\0\0\44\0\0\000non-blocking mode require unbuffered");
/*123*/ 	return ;
		}
/*124*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 24, io_0err_entry_get, 7) = TRUE;
	}
/*126*/ 	*(void **)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 8, io_0err_entry_get, 8) = NULL;
/*127*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 28, io_0err_entry_get, 9) = io_mode;
/*128*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 32, io_0err_entry_get, 10) = io_flags;
	if( io_unbuffered )  return;
	if( io_mode == 1 ){
		m = "r";
	} else if( io_mode == 2 ){
		if( io_flags & O_APPEND )
			m = "a";
		else
			m = "w";
	} else {
		if( io_flags & O_APPEND )
			m = "a+";
		else
			m = "r+";
	}

	io_b = (void *)fdopen(io_fd, m);
/*148*/ 	if( io_b == NULL ){
/*149*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 11, m2runtime_errno(), m2runtime_concat_STRING(0, io_fn, (STRING *) "\0\0\0\0\2\0\0\000: ", m2runtime_strerror(), 1));
/*150*/ 		*io_f = NULL;
/*152*/ 		return ;
/*154*/ 	}
/*154*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 20, io_0err_entry_get, 12) = FALSE;
/*155*/ 	*(void **)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 8, io_0err_entry_get, 13) = io_b;
/*159*/ }


/*162*/ void
/*162*/ io_Write(int try_section, RECORD *io_f, STRING *io_s)
/*162*/ {
/*163*/ 	int io_w = 0;
/*163*/ 	int io_n = 0;
/*163*/ 	int io_fd = 0;
/*164*/ 	void * io_b = NULL;
/*166*/ 	STRING * io_t = NULL;
/*166*/ 	if( io_f == NULL ){
/*167*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 14, 22, (STRING *) "\0\0\0\0\10\0\0\000NIL file");
/*169*/ 		return ;
/*170*/ 	}
/*170*/ 	if( (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 28, io_0err_entry_get, 15) & 2) == 0) ){
/*171*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 16, 22, (STRING *) "\0\0\0\0\26\0\0\000file open in read mode");
/*173*/ 		return ;
/*174*/ 	}
/*174*/ 	if( (((m2runtime_length(io_s) == 0)) && ((STRING *)m2runtime_dereference_rhs_RECORD(io_f, 12, io_0err_entry_get, 17) == NULL)) ){
/*176*/ 		return ;
/*177*/ 	}
/*177*/ 	if( ( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 18) == -1) ){
/*178*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 19, 22, (STRING *) "\0\0\0\0\20\0\0\000file just closed");
/*180*/ 		return ;
/*181*/ 	}
/*181*/ 	if(  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 20, io_0err_entry_get, 20) ){
/*183*/ 		io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 21);
/*185*/ 		if( (STRING *)m2runtime_dereference_rhs_RECORD(io_f, 12, io_0err_entry_get, 22) != NULL ){
/*187*/ 			io_t = (STRING *)m2runtime_dereference_rhs_RECORD(io_f, 12, io_0err_entry_get, 23);
/*188*/ 			io_w =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 36, io_0err_entry_get, 24);
/*190*/ 			do{
				io_n = TEMP_FAILURE_RETRY( write(io_fd, &io_t->s[io_w],
					io_t->len - io_w) );
/*192*/ 				if( (io_n < 0) ){
/*193*/ 					m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 25, m2runtime_errno(), m2runtime_strerror());
/*195*/ 					return ;
/*196*/ 				}
/*196*/ 				io_w = (io_w + io_n);
/*197*/ 				if( (io_w == m2runtime_length(io_t)) ){
/*198*/ 					*(STRING **)m2runtime_dereference_lhs_RECORD(&io_f, 40, 2, 12, io_0err_entry_get, 26) = NULL;
/*199*/ 					*(int *)m2runtime_dereference_lhs_RECORD(&io_f, 40, 2, 36, io_0err_entry_get, 27) = 0;
/*202*/ 					goto m2runtime_loop_1;
/*202*/ 				} else {
/*202*/ 					*(int *)m2runtime_dereference_lhs_RECORD(&io_f, 40, 2, 36, io_0err_entry_get, 28) = io_w;
/*204*/ 					return ;
/*206*/ 				}
/*207*/ 			}while(1);
m2runtime_loop_1: ;
/*209*/ 		}
/*209*/ 		io_w = 0;
/*211*/ 		do{
/*211*/ 			if( (io_w == m2runtime_length(io_s)) ){
/*213*/ 				return ;
/*214*/ 			}
			io_n = TEMP_FAILURE_RETRY( write(io_fd, &io_s->s[io_w],
				io_s->len - io_w) );
/*216*/ 			if( (io_n < 0) ){
/*217*/ 				if( (((m2runtime_errno() == 11)) && ((io_w > 0))) ){
/*218*/ 					*(STRING **)m2runtime_dereference_lhs_RECORD(&io_f, 40, 2, 12, io_0err_entry_get, 29) = io_s;
/*219*/ 					*(int *)m2runtime_dereference_lhs_RECORD(&io_f, 40, 2, 36, io_0err_entry_get, 30) = io_w;
/*221*/ 				} else {
/*221*/ 					m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 31, m2runtime_errno(), m2runtime_strerror());
/*224*/ 				}
/*224*/ 				return ;
/*225*/ 			}
/*225*/ 			io_w = (io_w + io_n);
/*229*/ 		}while(1);
/*230*/ 	} else {
/*230*/ 		io_b = (void *)m2runtime_dereference_rhs_RECORD(io_f, 8, io_0err_entry_get, 32);
		io_n = TEMP_FAILURE_RETRY( fwrite(io_s->s, io_s->len, 1,
			(FILE * )io_b) );
/*233*/ 		if( (io_n == 0) ){
/*234*/ 			m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 33, m2runtime_errno(), m2runtime_strerror());
/*236*/ 			return ;
/*239*/ 		}
/*240*/ 	}
/*242*/ }


/*244*/ int
/*244*/ io_Written(RECORD *io_f)
/*244*/ {
/*244*/ 	if( ((io_f == NULL) || (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 34) == -1))) ){
/*245*/ 		return TRUE;
/*247*/ 	}
/*247*/ 	return (STRING *)m2runtime_dereference_rhs_RECORD(io_f, 12, io_0err_entry_get, 35) == NULL;
/*251*/ }


/*254*/ STRING *
/*254*/ io_Read(int try_section, RECORD *io_f, int io_max)
/*254*/ {
/*255*/ 	int io_n = 0;
/*255*/ 	int io_fd = 0;
/*256*/ 	void * io_b = NULL;
	unsigned char *buf;
/*258*/ 	if( io_f == NULL ){
/*259*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 36, 22, (STRING *) "\0\0\0\0\10\0\0\000NIL file");
/*260*/ 		return NULL;
/*262*/ 	}
/*262*/ 	if( (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 28, io_0err_entry_get, 37) & 1) == 0) ){
/*263*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 38, 22, (STRING *) "\0\0\0\0\27\0\0\000file open in write mode");
/*264*/ 		return NULL;
/*266*/ 	}
/*266*/ 	if( ( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 39) == -1) ){
/*267*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 40, 22, (STRING *) "\0\0\0\0\20\0\0\000file just closed");
/*268*/ 		return NULL;
/*270*/ 	}
/*270*/ 	if( (io_max < 0) ){
/*271*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 41, 22, (STRING *) "\0\0\0\0\47\0\0\000argument `max' must be positive or zero");
/*273*/ 	}
/*273*/ 	if( (io_max == 0) ){
/*274*/ 		return NULL;
/*277*/ 	}
	buf = alloca(io_max);
/*279*/ 	if(  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 20, io_0err_entry_get, 42) ){
/*281*/ 		io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 43);
		io_n = TEMP_FAILURE_RETRY( read(io_fd, buf, io_max) );
/*283*/ 		if( (io_n < 0) ){
/*284*/ 			m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 44, m2runtime_errno(), m2runtime_strerror());
/*285*/ 			return NULL;
/*287*/ 		}
/*287*/ 		if( (io_n == 0) ){
/*288*/ 			return NULL;
/*292*/ 		}
/*293*/ 	} else {
/*293*/ 		io_b = (void *)m2runtime_dereference_rhs_RECORD(io_f, 8, io_0err_entry_get, 45);
		io_n = TEMP_FAILURE_RETRY( fread(buf, 1, io_max, (FILE *)io_b) );
/*295*/ 		if( (io_n == 0) ){
			if( feof((FILE *)io_b) ){
/*297*/ 			return NULL;
			} else if( ferror((FILE *)io_b) ){
/*299*/ 			m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 46, m2runtime_errno(), m2runtime_strerror());
/*300*/ 			return NULL;
			} else {
/*302*/ 			m2runtime_HALT(io_0err_entry_get, 47, (STRING *) "\0\0\0\0\64\0\0\000unexpected condition: no more data, no EOF, no error");
/*303*/ 			return NULL;
			}
/*305*/ 		} else if( (io_n < io_max) ){
			if( ferror((FILE *)io_b) ){
/*307*/ 			m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 48, m2runtime_errno(), m2runtime_strerror());
/*308*/ 			return NULL;
			}
/*313*/ 		}
/*314*/ 	}
	return new_STRING(buf, io_n);
/*316*/ 	m2runtime_missing_return(io_0err_entry_get, 49);
/*316*/ 	return NULL;
/*318*/ }

/*320*/ void * io_line = NULL;

/*323*/ STRING *
/*323*/ io_ReadLine(int try_section, RECORD *io_f)
/*323*/ {
/*325*/ 	STRING * io_c = NULL;
/*325*/ 	if( io_f == NULL ){
/*326*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 50, 22, (STRING *) "\0\0\0\0\10\0\0\000NIL file");
/*327*/ 		return NULL;
/*329*/ 	}
/*329*/ 	if( (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 28, io_0err_entry_get, 51) & 1) == 0) ){
/*330*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 52, 22, (STRING *) "\0\0\0\0\27\0\0\000file open in write mode");
/*331*/ 		return NULL;
/*333*/ 	}
/*333*/ 	if( ( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 53) == -1) ){
/*334*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 54, 22, (STRING *) "\0\0\0\0\20\0\0\000file just closed");
/*335*/ 		return NULL;
/*337*/ 	}
/*337*/ 	buffer_Empty((void *)&io_line);
/*340*/ 	do{
/*340*/ 		m2runtime_ERROR_CODE = 0;
/*340*/ 		io_c = io_Read(1, io_f, 1);
/*342*/ 		switch( m2runtime_ERROR_CODE ){

/*342*/ 		case 0:  break;
/*342*/ 		default:
/*342*/ 			m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 55, m2runtime_ERROR_CODE, m2runtime_ERROR_MESSAGE);
/*343*/ 			return buffer_ToString(io_line);
/*345*/ 		}
/*345*/ 		if( io_c == NULL ){
/*346*/ 			if( (buffer_Length(io_line) == 0) ){
/*347*/ 				return NULL;
/*349*/ 			} else {
/*349*/ 				return buffer_ToString(io_line);
/*351*/ 			}
/*351*/ 		} else if( m2runtime_strcmp(io_c, m2runtime_CHR(10)) == 0 ){
/*352*/ 			if( (buffer_Length(io_line) == 0) ){
/*353*/ 				return EMPTY_STRING;
/*355*/ 			} else {
/*355*/ 				return buffer_ToString(io_line);
/*358*/ 			}
/*358*/ 		}
/*358*/ 		buffer_AddString((void *)&io_line, io_c);
/*361*/ 	}while(1);
/*361*/ 	m2runtime_missing_return(io_0err_entry_get, 56);
/*361*/ 	return NULL;
/*363*/ }


/*366*/ void
/*366*/ io_Close(int try_section, RECORD **io_f)
/*366*/ {
/*367*/ 	int io_fd = 0;
/*368*/ 	void * io_b = NULL;
/*370*/ 	int io_err = 0;
/*370*/ 	if( *io_f == NULL ){
/*371*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 57, 22, (STRING *) "\0\0\0\0\10\0\0\000NIL file");
/*373*/ 		return ;
/*374*/ 	}
/*374*/ 	if( ( *(int *)m2runtime_dereference_rhs_RECORD(*io_f, 16, io_0err_entry_get, 58) == -1) ){
/*375*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 59, 22, (STRING *) "\0\0\0\0\20\0\0\000file just closed");
/*377*/ 		return ;
/*378*/ 	}
/*378*/ 	if(  *(int *)m2runtime_dereference_rhs_RECORD(*io_f, 20, io_0err_entry_get, 60) ){
/*380*/ 		io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(*io_f, 16, io_0err_entry_get, 61);
		io_err = TEMP_FAILURE_RETRY( close(io_fd) );
/*382*/ 		if( (io_err == -1) ){
/*383*/ 			m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 62, m2runtime_errno(), m2runtime_strerror());
/*387*/ 		}
/*388*/ 	} else {
/*388*/ 		io_b = (void *)m2runtime_dereference_rhs_RECORD(*io_f, 8, io_0err_entry_get, 63);
		if( fclose((FILE *) io_b) ){
/*390*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 64, m2runtime_errno(), m2runtime_strerror());
		}
/*394*/ 	}
/*394*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_f, 40, 2, 16, io_0err_entry_get, 65) = -1;
/*395*/ 	*io_f = NULL;
/*399*/ }


/*401*/ int
/*401*/ io_parse_mode(STRING *io_m)
/*401*/ {
/*402*/ 	int io_b = 0;
/*402*/ 	int io_mode = 0;
/*403*/ 	STRING * io_who = NULL;
/*403*/ 	STRING * io_c = NULL;
/*405*/ 	int io_i = 0;

/*407*/ 	void
/*407*/ 	io_next(void)
/*407*/ 	{
/*407*/ 		if( (io_i >= m2runtime_length(io_m)) ){
/*408*/ 			io_c = NULL;
/*410*/ 		} else {
/*410*/ 			io_c = m2runtime_substr(io_m, io_i, 0, 0, io_0err_entry_get, 66);
/*412*/ 		}
/*412*/ 		io_i = (io_i + 1);
/*416*/ 	}

/*416*/ 	if( (m2runtime_length(io_m) == 0) ){
/*417*/ 		return 0;
/*419*/ 	}
/*419*/ 	io_mode = 0;
/*420*/ 	io_next();
/*422*/ 	do{
/*422*/ 		if( ((m2runtime_strcmp(io_c, m2runtime_CHR(117)) != 0) && (m2runtime_strcmp(io_c, m2runtime_CHR(103)) != 0) && (m2runtime_strcmp(io_c, m2runtime_CHR(111)) != 0)) ){
/*423*/ 			return -1;
/*425*/ 		}
/*425*/ 		io_who = io_c;
/*426*/ 		io_next();
/*427*/ 		if( m2runtime_strcmp(io_c, m2runtime_CHR(61)) != 0 ){
/*428*/ 			return -1;
/*430*/ 		}
/*430*/ 		io_next();
/*431*/ 		while( ((m2runtime_strcmp(io_c, m2runtime_CHR(114)) == 0) || (m2runtime_strcmp(io_c, m2runtime_CHR(119)) == 0) || (m2runtime_strcmp(io_c, m2runtime_CHR(120)) == 0)) ){
/*432*/ 			if( m2runtime_strcmp(io_c, m2runtime_CHR(114)) == 0 ){
/*432*/ 				io_b = 4;
/*433*/ 			} else if( m2runtime_strcmp(io_c, m2runtime_CHR(119)) == 0 ){
/*433*/ 				io_b = 2;
/*434*/ 			} else {
/*434*/ 				io_b = 1;
/*436*/ 			}
/*436*/ 			if( m2runtime_strcmp(io_who, m2runtime_CHR(117)) == 0 ){
/*436*/ 				io_b = ((unsigned int) io_b << 6);
/*437*/ 			} else if( m2runtime_strcmp(io_who, m2runtime_CHR(103)) == 0 ){
/*437*/ 				io_b = ((unsigned int) io_b << 3);
/*439*/ 			}
/*439*/ 			io_mode = (io_mode | io_b);
/*440*/ 			io_next();
/*442*/ 		}
/*442*/ 		if( io_c == NULL ){
/*443*/ 			return io_mode;
/*444*/ 		} else if( m2runtime_strcmp(io_c, m2runtime_CHR(44)) == 0 ){
/*445*/ 			io_next();
/*447*/ 		} else {
/*447*/ 			return -1;
/*450*/ 		}
/*451*/ 	}while(1);
/*451*/ 	m2runtime_missing_return(io_0err_entry_get, 67);
/*451*/ 	return 0;
/*453*/ }


/*455*/ STRING *
/*455*/ io_GetMask(void)
/*455*/ {
/*457*/ 	int io_u = 0;

/*459*/ 	STRING *
/*459*/ 	io_if(int io_b, STRING *io_s)
/*459*/ 	{
/*459*/ 		if( (((io_u & io_b)) == 0) ){
/*460*/ 			return NULL;
/*462*/ 		} else {
/*462*/ 			return io_s;
/*465*/ 		}
/*465*/ 		m2runtime_missing_return(io_0err_entry_get, 68);
/*465*/ 		return NULL;
/*467*/ 	}

	io_u = umask(0);   umask(io_u);
/*468*/ 	io_u = ~io_u;
/*470*/ 	return m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\2\0\0\000u=", io_if(((unsigned int) 4 << 6), m2runtime_CHR(114)), io_if(((unsigned int) 2 << 6), m2runtime_CHR(119)), io_if(((unsigned int) 1 << 6), m2runtime_CHR(120)), (STRING *) "\0\0\0\0\3\0\0\000,g=", io_if(((unsigned int) 4 << 3), m2runtime_CHR(114)), io_if(((unsigned int) 2 << 3), m2runtime_CHR(119)), io_if(((unsigned int) 1 << 3), m2runtime_CHR(120)), (STRING *) "\0\0\0\0\3\0\0\000,o=", io_if(4, m2runtime_CHR(114)), io_if(2, m2runtime_CHR(119)), io_if(1, m2runtime_CHR(120)), 1);
/*476*/ }


/*477*/ void
/*477*/ io_SetMask(STRING *io_mode)
/*477*/ {
/*479*/ 	int io_x = 0;
/*479*/ 	io_x = io_parse_mode(io_mode);
/*480*/ 	if( (io_x == -1) ){
/*481*/ 		m2runtime_HALT(io_0err_entry_get, 69, m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\15\0\0\000invalid mode ", m2runtime_StringToLiteral(io_mode), 1));
/*483*/ 	}
	umask(~io_x);
/*488*/ }


/*504*/ RECORD *
/*504*/ io_PoolSetNew(void)
/*504*/ {
/*506*/ 	RECORD * io_ps = NULL;
/*506*/ 	*(int *)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 24, io_0err_entry_get, 70) = -1;
/*507*/ 	*(int *)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 28, io_0err_entry_get, 71) = -1;
/*508*/ 	return io_ps;
/*512*/ }


/*514*/ void
/*514*/ io_SetTimeout(RECORD **io_ps, int io_sec, int io_usec)
/*514*/ {
/*514*/ 	if( (((io_sec < 0)) || ((io_usec < 0)) || ((io_usec > 999999))) ){
/*517*/ 		return ;
/*518*/ 	}
/*518*/ 	if( *io_ps == NULL ){
/*519*/ 		*io_ps = io_PoolSetNew();
/*521*/ 	}
/*521*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_ps, 44, 4, 32, io_0err_entry_get, 72) = io_sec;
/*522*/ 	*(int *)m2runtime_dereference_lhs_RECORD(io_ps, 44, 4, 36, io_0err_entry_get, 73) = io_usec;
/*526*/ }


/*528*/ void
/*528*/ io_Wait(RECORD *io_ps)
/*528*/ {
/*529*/ 	void * io_write_ready_fs = NULL;
/*529*/ 	void * io_read_ready_fs = NULL;
/*529*/ 	void * io_write_fs = NULL;
/*529*/ 	void * io_read_fs = NULL;
/*530*/ 	int io_n = 0;
/*530*/ 	int io_usec = 0;
/*530*/ 	int io_sec = 0;
/*530*/ 	int io_max = 0;
/*530*/ 	int io_write_max = 0;
/*530*/ 	int io_read_max = 0;
	struct timeval tv;
	struct timeval *tvp;
/*533*/ 	m2runtime_mark(&io_n);
/*534*/ 	if( io_ps == NULL ){
/*536*/ 		return ;
/*537*/ 	}
/*537*/ 	io_read_max =  *(int *)m2runtime_dereference_rhs_RECORD(io_ps, 24, io_0err_entry_get, 74);
/*538*/ 	io_write_max =  *(int *)m2runtime_dereference_rhs_RECORD(io_ps, 28, io_0err_entry_get, 75);
/*539*/ 	io_sec =  *(int *)m2runtime_dereference_rhs_RECORD(io_ps, 32, io_0err_entry_get, 76);
/*540*/ 	io_usec =  *(int *)m2runtime_dereference_rhs_RECORD(io_ps, 36, io_0err_entry_get, 77);
/*541*/ 	if( (((io_read_max == -1)) && ((io_write_max == -1)) && ((io_sec == 0)) && ((io_usec == 0))) ){
/*543*/ 		*(int *)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 40, io_0err_entry_get, 78) = FALSE;
/*545*/ 		return ;
/*547*/ 	}
/*547*/ 	io_max = io_read_max;
/*548*/ 	if( (io_write_max > io_max) ){
/*549*/ 		io_max = io_write_max;
/*552*/ 	}
/*552*/ 	if( (io_read_max >= 0) ){
/*553*/ 		io_read_fs = (void *)m2runtime_dereference_rhs_RECORD(io_ps, 8, io_0err_entry_get, 79);
/*554*/ 		io_read_ready_fs = (void *)m2runtime_dereference_rhs_RECORD(io_ps, 12, io_0err_entry_get, 80);
/*555*/ 		if( io_read_ready_fs == NULL ){
			io_read_ready_fs = M2_MALLOC_ATOMIC( sizeof( fd_set ) );
/*557*/ 			*(void **)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 12, io_0err_entry_get, 81) = io_read_ready_fs;
/*559*/ 		}
		memcpy(io_read_ready_fs, io_read_fs, sizeof( fd_set ) );
		FD_ZERO((fd_set * )io_read_fs);
/*561*/ 		*(int *)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 24, io_0err_entry_get, 82) = -1;
/*564*/ 	}
/*564*/ 	if( (io_write_max >= 0) ){
/*565*/ 		io_write_fs = (void *)m2runtime_dereference_rhs_RECORD(io_ps, 16, io_0err_entry_get, 83);
/*566*/ 		io_write_ready_fs = (void *)m2runtime_dereference_rhs_RECORD(io_ps, 20, io_0err_entry_get, 84);
/*567*/ 		if( io_write_ready_fs == NULL ){
			io_write_ready_fs = M2_MALLOC_ATOMIC( sizeof( fd_set ) );
/*569*/ 			*(void **)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 20, io_0err_entry_get, 85) = io_write_ready_fs;
/*571*/ 		}
		memcpy(io_write_ready_fs, io_write_fs, sizeof( fd_set ) );
		FD_ZERO((fd_set * )io_write_fs);
/*573*/ 		*(int *)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 28, io_0err_entry_get, 86) = -1;
/*576*/ 	}
/*576*/ 	if( (((io_sec == 0)) && ((io_usec == 0))) ){
		tvp = NULL;
/*579*/ 	} else {
		tv.tv_sec = io_sec;
		tv.tv_usec = io_usec;
		tvp = &tv;
/*584*/ 	}
	io_n = TEMP_FAILURE_RETRY( select(io_max + 1,
		io_read_ready_fs, io_write_ready_fs,
		NULL, tvp) );
/*588*/ 	if( (io_n == -1) ){
/*589*/ 		m2runtime_HALT(io_0err_entry_get, 87, m2runtime_strerror());
/*592*/ 	}
/*592*/ 	*(int *)m2runtime_dereference_lhs_RECORD(&io_ps, 44, 4, 40, io_0err_entry_get, 88) = (io_n == 0);
/*596*/ }


/*598*/ int
/*598*/ io_Timeout(RECORD *io_ps)
/*598*/ {
/*598*/ 	return ((io_ps == NULL) ||  *(int *)m2runtime_dereference_rhs_RECORD(io_ps, 40, io_0err_entry_get, 89));
/*602*/ }


/*604*/ int
/*604*/ io_Readable(RECORD **io_ps, RECORD *io_f)
/*604*/ {
/*605*/ 	int io_fd = 0;
/*607*/ 	void * io_fs = NULL;
/*607*/ 	if( ((io_f == NULL) || (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 90) == -1))) ){
/*608*/ 		return FALSE;
/*610*/ 	}
/*610*/ 	if( (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 28, io_0err_entry_get, 91) & 1) == 0) ){
/*612*/ 		return FALSE;
/*615*/ 	}
/*615*/ 	if( *io_ps == NULL ){
/*616*/ 		*io_ps = io_PoolSetNew();
/*619*/ 	}
/*619*/ 	io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 92);
/*620*/ 	if( (void *)m2runtime_dereference_rhs_RECORD(*io_ps, 8, io_0err_entry_get, 93) == NULL ){
		io_fs = M2_MALLOC_ATOMIC( sizeof(fd_set) );
		FD_ZERO((fd_set * ) io_fs);
/*623*/ 		*(void **)m2runtime_dereference_lhs_RECORD(io_ps, 44, 4, 8, io_0err_entry_get, 94) = io_fs;
/*625*/ 	} else {
/*625*/ 		io_fs = (void *)m2runtime_dereference_rhs_RECORD(*io_ps, 8, io_0err_entry_get, 95);
/*627*/ 	}
	FD_SET(io_fd, (fd_set * ) io_fs);
/*628*/ 	if( (io_fd >  *(int *)m2runtime_dereference_rhs_RECORD(*io_ps, 24, io_0err_entry_get, 96)) ){
/*629*/ 		*(int *)m2runtime_dereference_lhs_RECORD(io_ps, 44, 4, 24, io_0err_entry_get, 97) = io_fd;
/*632*/ 	}
/*632*/ 	io_fs = (void *)m2runtime_dereference_rhs_RECORD(*io_ps, 12, io_0err_entry_get, 98);
/*633*/ 	if( io_fs == NULL ){
/*634*/ 		return FALSE;
/*636*/ 	}
/*636*/ 	io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 99);
	if( FD_ISSET(io_fd, (fd_set * ) io_fs) ){
		FD_CLR(io_fd, (fd_set * ) io_fs);
		return TRUE;
	} else {
		return FALSE;
	}
/*644*/ 	m2runtime_missing_return(io_0err_entry_get, 100);
/*644*/ 	return 0;
/*646*/ }


/*648*/ int
/*648*/ io_Writable(RECORD **io_ps, RECORD *io_f)
/*648*/ {
/*649*/ 	int io_fd = 0;
/*651*/ 	void * io_fs = NULL;
/*651*/ 	if( ((io_f == NULL) || (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 101) == -1))) ){
/*652*/ 		return FALSE;
/*654*/ 	}
/*654*/ 	if( (( *(int *)m2runtime_dereference_rhs_RECORD(io_f, 28, io_0err_entry_get, 102) & 2) == 0) ){
/*656*/ 		return FALSE;
/*659*/ 	}
/*659*/ 	if( *io_ps == NULL ){
/*660*/ 		*io_ps = io_PoolSetNew();
/*663*/ 	}
/*663*/ 	io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 103);
/*664*/ 	if( (void *)m2runtime_dereference_rhs_RECORD(*io_ps, 16, io_0err_entry_get, 104) == NULL ){
		io_fs = M2_MALLOC_ATOMIC( sizeof(fd_set) );
		FD_ZERO((fd_set * ) io_fs);
/*667*/ 		*(void **)m2runtime_dereference_lhs_RECORD(io_ps, 44, 4, 16, io_0err_entry_get, 105) = io_fs;
/*669*/ 	} else {
/*669*/ 		io_fs = (void *)m2runtime_dereference_rhs_RECORD(*io_ps, 16, io_0err_entry_get, 106);
/*671*/ 	}
	FD_SET(io_fd, (fd_set * ) io_fs);
/*672*/ 	if( (io_fd >  *(int *)m2runtime_dereference_rhs_RECORD(*io_ps, 28, io_0err_entry_get, 107)) ){
/*673*/ 		*(int *)m2runtime_dereference_lhs_RECORD(io_ps, 44, 4, 28, io_0err_entry_get, 108) = io_fd;
/*676*/ 	}
/*676*/ 	io_fs = (void *)m2runtime_dereference_rhs_RECORD(*io_ps, 20, io_0err_entry_get, 109);
/*677*/ 	if( io_fs == NULL ){
/*678*/ 		return FALSE;
/*680*/ 	}
/*680*/ 	io_fd =  *(int *)m2runtime_dereference_rhs_RECORD(io_f, 16, io_0err_entry_get, 110);
	if( FD_ISSET(io_fd, (fd_set * ) io_fs) ){
		FD_CLR(io_fd, (fd_set * ) io_fs);
		return TRUE;
	} else {
		return FALSE;
	}
/*688*/ 	m2runtime_missing_return(io_0err_entry_get, 111);
/*688*/ 	return 0;
/*690*/ }


/*693*/ STRING *
/*693*/ io_GetCWD(int try_section)
/*693*/ {
/*694*/ 	STRING * io_p = NULL;
	unsigned char *s;
	int s_size;
	s_size = 100;
	s = M2_MALLOC_ATOMIC(s_size);
	while( getcwd(s, s_size) == NULL ){
		if( errno == ERANGE ){
			s_size = 2*s_size;
			s = M2_MALLOC_ATOMIC(s_size);
		} else {
/*704*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 112, m2runtime_errno(), m2runtime_strerror());
/*705*/ 	return NULL;
		}
	}
	io_p = new_STRING(s, strlen(s));
/*709*/ 	return io_p;
/*713*/ }


/*716*/ void
/*716*/ io_ChDir(int try_section, STRING *io_p)
/*716*/ {
	char *pz;
/*718*/ 	if( m2runtime_InvalidZString(io_p) ){
/*719*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 113, 22, m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_p), (STRING *) "\0\0\0\0\54\0\0\000: pathfile NIL or containing a NUL character", 1));
/*721*/ 		return ;
/*722*/ 	}
	MK_ZSTRING(pz, io_p);
	if( chdir(pz) != 0 ){
/*724*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 114, m2runtime_errno(), m2runtime_concat_STRING(0, io_p, (STRING *) "\0\0\0\0\2\0\0\000: ", m2runtime_strerror(), 1));
	}
/*729*/ }


/*732*/ void
/*732*/ io_Unlink(int try_section, STRING *io_f)
/*732*/ {
	char *fz;
/*734*/ 	if( m2runtime_InvalidZString(io_f) ){
/*735*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 115, 22, m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_f), (STRING *) "\0\0\0\0\54\0\0\000: pathfile NIL or containing a NUL character", 1));
/*737*/ 		return ;
/*738*/ 	}
	MK_ZSTRING(fz, io_f);
	if( remove(fz) == 0 )  return;
/*740*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 116, m2runtime_errno(), m2runtime_concat_STRING(0, io_f, (STRING *) "\0\0\0\0\2\0\0\000: ", m2runtime_strerror(), 1));
/*744*/ }


/*747*/ void
/*747*/ io_Rename(int try_section, STRING *io_old, STRING *io_new)
/*747*/ {
 char *oldz, *newz;
/*749*/ 	if( (m2runtime_InvalidZString(io_old) || m2runtime_InvalidZString(io_new)) ){
/*750*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 117, 22, m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_old), (STRING *) "\0\0\0\0\2\0\0\000, ", m2runtime_StringToLiteral(io_new), (STRING *) "\0\0\0\0\54\0\0\000: pathfile NIL or containing a NUL character", 1));
/*753*/ 		return ;
/*754*/ 	}
	MK_ZSTRING(oldz, io_old);
	MK_ZSTRING(newz, io_new);
	if( rename(oldz, newz) == 0 )  return;
/*757*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 118, m2runtime_errno(), m2runtime_concat_STRING(0, io_old, (STRING *) "\0\0\0\0\2\0\0\000, ", io_new, (STRING *) "\0\0\0\0\2\0\0\000: ", m2runtime_strerror(), 1));
/*761*/ }


/*764*/ void
/*764*/ io_MkDir(int try_section, STRING *io_d, STRING *io_mode)
/*764*/ {
/*765*/ 	int io_x = 0;
	char *dz;
/*767*/ 	if( m2runtime_InvalidZString(io_d) ){
/*768*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 119, 22, m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_d), (STRING *) "\0\0\0\0\54\0\0\000: pathfile NIL or containing a NUL character", 1));
/*770*/ 		return ;
/*771*/ 	}
/*771*/ 	io_x = io_parse_mode(io_mode);
/*772*/ 	if( (io_x == -1) ){
/*773*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 120, 22, m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\15\0\0\000invalid mode ", m2runtime_StringToLiteral(io_mode), 1));
/*775*/ 		return ;
/*776*/ 	}
	MK_ZSTRING(dz, io_d);
	if( mkdir(dz, io_x) == 0 )  return;
/*778*/ 	m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 121, m2runtime_errno(), m2runtime_concat_STRING(0, io_d, (STRING *) "\0\0\0\0\7\0\0\000, mode=", io_mode, (STRING *) "\0\0\0\0\2\0\0\000: ", m2runtime_strerror(), 1));
/*782*/ }


/*784*/ void
/*784*/ io_Touch(int try_section, STRING *io_fn)
/*784*/ {
/*786*/ 	RECORD * io_f = NULL;
/*786*/ 	if( m2runtime_InvalidZString(io_fn) ){
/*787*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 122, 22, m2runtime_concat_STRING(0, m2runtime_StringToLiteral(io_fn), (STRING *) "\0\0\0\0\54\0\0\000: pathfile NIL or containing a NUL character", 1));
/*789*/ 		return ;
/*791*/ 	}
/*791*/ 	m2runtime_ERROR_CODE = 0;
/*791*/ 	io_Open(1, &io_f, io_fn, (STRING *) "\0\0\0\0\2\0\0\000wc");
/*793*/ 	switch( m2runtime_ERROR_CODE ){

/*793*/ 	case 0:  break;
/*793*/ 	default:
/*793*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 123, m2runtime_ERROR_CODE, m2runtime_ERROR_MESSAGE);
/*795*/ 		return ;
/*797*/ 	}
/*797*/ 	m2runtime_ERROR_CODE = 0;
/*797*/ 	io_Close(1, &io_f);
/*799*/ 	switch( m2runtime_ERROR_CODE ){

/*799*/ 	case 0:  break;
/*799*/ 	default:
/*799*/ 		m2runtime_RAISE_ERROR(try_section, io_0err_entry_get, 124, m2runtime_ERROR_CODE, m2runtime_ERROR_MESSAGE);
/*802*/ 	}
/*805*/ }


char * io_0func[] = {
    "Open",
    "Write",
    "Written",
    "Read",
    "ReadLine",
    "Close",
    "next",
    "parse_mode",
    "if",
    "SetMask",
    "PoolSetNew",
    "SetTimeout",
    "Wait",
    "Timeout",
    "Readable",
    "Writable",
    "GetCWD",
    "ChDir",
    "Unlink",
    "Rename",
    "MkDir",
    "Touch"
};

int io_0err_entry[] = {
    0 /* Open */, 67,
    0 /* Open */, 96,
    0 /* Open */, 102,
    0 /* Open */, 114,
    0 /* Open */, 117,
    0 /* Open */, 118,
    0 /* Open */, 121,
    0 /* Open */, 124,
    0 /* Open */, 126,
    0 /* Open */, 127,
    0 /* Open */, 128,
    0 /* Open */, 149,
    0 /* Open */, 154,
    0 /* Open */, 155,
    1 /* Write */, 167,
    1 /* Write */, 170,
    1 /* Write */, 171,
    1 /* Write */, 174,
    1 /* Write */, 177,
    1 /* Write */, 178,
    1 /* Write */, 181,
    1 /* Write */, 183,
    1 /* Write */, 185,
    1 /* Write */, 187,
    1 /* Write */, 188,
    1 /* Write */, 193,
    1 /* Write */, 198,
    1 /* Write */, 199,
    1 /* Write */, 202,
    1 /* Write */, 218,
    1 /* Write */, 219,
    1 /* Write */, 221,
    1 /* Write */, 230,
    1 /* Write */, 234,
    2 /* Written */, 244,
    2 /* Written */, 247,
    3 /* Read */, 259,
    3 /* Read */, 262,
    3 /* Read */, 263,
    3 /* Read */, 266,
    3 /* Read */, 267,
    3 /* Read */, 271,
    3 /* Read */, 279,
    3 /* Read */, 281,
    3 /* Read */, 284,
    3 /* Read */, 293,
    3 /* Read */, 299,
    3 /* Read */, 302,
    3 /* Read */, 307,
    3 /* Read */, 315,
    4 /* ReadLine */, 326,
    4 /* ReadLine */, 329,
    4 /* ReadLine */, 330,
    4 /* ReadLine */, 333,
    4 /* ReadLine */, 334,
    4 /* ReadLine */, 342,
    4 /* ReadLine */, 360,
    5 /* Close */, 371,
    5 /* Close */, 374,
    5 /* Close */, 375,
    5 /* Close */, 378,
    5 /* Close */, 380,
    5 /* Close */, 383,
    5 /* Close */, 388,
    5 /* Close */, 390,
    5 /* Close */, 394,
    6 /* next */, 410,
    7 /* parse_mode */, 450,
    8 /* if */, 464,
    9 /* SetMask */, 481,
    10 /* PoolSetNew */, 506,
    10 /* PoolSetNew */, 507,
    11 /* SetTimeout */, 521,
    11 /* SetTimeout */, 522,
    12 /* Wait */, 537,
    12 /* Wait */, 538,
    12 /* Wait */, 539,
    12 /* Wait */, 540,
    12 /* Wait */, 543,
    12 /* Wait */, 553,
    12 /* Wait */, 554,
    12 /* Wait */, 557,
    12 /* Wait */, 561,
    12 /* Wait */, 565,
    12 /* Wait */, 566,
    12 /* Wait */, 569,
    12 /* Wait */, 573,
    12 /* Wait */, 589,
    12 /* Wait */, 592,
    13 /* Timeout */, 598,
    14 /* Readable */, 607,
    14 /* Readable */, 610,
    14 /* Readable */, 619,
    14 /* Readable */, 620,
    14 /* Readable */, 623,
    14 /* Readable */, 625,
    14 /* Readable */, 628,
    14 /* Readable */, 629,
    14 /* Readable */, 632,
    14 /* Readable */, 636,
    14 /* Readable */, 643,
    15 /* Writable */, 651,
    15 /* Writable */, 654,
    15 /* Writable */, 663,
    15 /* Writable */, 664,
    15 /* Writable */, 667,
    15 /* Writable */, 669,
    15 /* Writable */, 672,
    15 /* Writable */, 673,
    15 /* Writable */, 676,
    15 /* Writable */, 680,
    15 /* Writable */, 687,
    16 /* GetCWD */, 704,
    17 /* ChDir */, 719,
    17 /* ChDir */, 724,
    18 /* Unlink */, 735,
    18 /* Unlink */, 740,
    19 /* Rename */, 750,
    19 /* Rename */, 757,
    20 /* MkDir */, 768,
    20 /* MkDir */, 773,
    20 /* MkDir */, 778,
    21 /* Touch */, 787,
    21 /* Touch */, 793,
    21 /* Touch */, 799
};

void io_0err_entry_get(int i, char **m, char **f, int *l)
{
    *m = "io";
    *f = io_0func[ io_0err_entry[2*i] ];
    *l = io_0err_entry[2*i + 1];
}
